package main;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import com.google.gson.JsonObject;
import com.huawei.iota.bind.BindConfig;
import com.huawei.iota.bind.BindService;
import com.huawei.iota.iodev.IotaDeviceInfo;
import com.huawei.iota.login.LoginService;
import com.huawei.iota.util.IotaMessage;
import com.huawei.iota.util.MyObserver;

import bean.GatewayInfo;

public class AgentLiteBind implements MyObserver {
	
	public static IotaDeviceInfo deviceInfo = null;
	
	private static AgentLiteBind instance = new AgentLiteBind();
	
	private static final String  PLATFORM_IP = "100.114.224.237";
	private static final String  HTTPS_PORT = "8943";
	
    public static AgentLiteBind getInstance() {
        return instance;
    }
		
	public void bindAction() {
		System.out.println(" =============   start  bind ============== ");
		String nodeId = "80000001";
		String preSecret = "22222222";
		String manufactrueId = "Huawei";
		String deviceType = "Gateway";
		String model = "AgentLite01";
		String protocolType = "LWM2M";
		deviceInfo = new IotaDeviceInfo(nodeId, manufactrueId, deviceType, model, protocolType);
		
		//
		configBindPara();
		
		//
		BindService.bind(preSecret, deviceInfo);
	}
	
	
	//
	private static void configBindPara() {
		boolean res = false;
		res = BindConfig.setConfig(BindConfig.BIND_CONFIG_ADDR, PLATFORM_IP);
		res = BindConfig.setConfig(BindConfig.BIND_CONFIG_PORT, HTTPS_PORT);

		if (false == res) {
			System.out.println(" ============ set BindConfig failed ============");
		}
		System.out.println("startBind platformIP =" + "100.112.166.188" + ":" + "8943");		
	}
	
    //ӦϢЯĲ
    private void saveBindParaAndGotoLogin(IotaMessage iotaMsg) {
        System.out.println(" ============ saveBindParaAndGotoLogin ============");
        String appId = iotaMsg.getString(BindService.BIND_IE_APPID);
        String deviceId = iotaMsg.getString(BindService.BIND_IE_DEVICEID);
        String secret = iotaMsg.getString(BindService.BIND_IE_DEVICESECRET);

        GatewayInfo.setAppID(appId);
        GatewayInfo.setDeviceID(deviceId);
        GatewayInfo.setSecret(secret);
        
        saveGatewayInfo();
		AgentLiteLogin agentLiteLogin = AgentLiteLogin.getInstance();
		LoginService loginService = LoginService.getInstance();
		loginService.registerObserver(agentLiteLogin);
		agentLiteLogin.loginAction();
    }
    
    private void saveGatewayInfo() {
         JsonObject data = new JsonObject();
         data.addProperty("deviceId", GatewayInfo.getDeviceID());
         data.addProperty("deviceSecret", GatewayInfo.getSecret());
         data.addProperty("appId", GatewayInfo.getAppID());
         
         File file = new File("./workdir/gwbindinfo.json");
         if(!file.exists()){
             try {
                 file.createNewFile();
             } catch (IOException e) {
                 e.printStackTrace();
             }
         }
         
         BufferedWriter writer = null;
         try {
             writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file,false), "UTF-8"));
             writer.write(data.toString());
         } catch (IOException e) {
             e.printStackTrace();
         }finally {
             try {
                 if(writer != null){
                     writer.close();
                 }
             } catch (IOException e) {
                 e.printStackTrace();
             }
         }
    }
    
	@Override
	public void update(IotaMessage arg0) {
		// TODO Auto-generated method stub
		System.out.println("BindManagerյ֪ͨ:" + arg0);
		int status = arg0.getUint(BindService.BIND_IE_RESULT, -1);
		System.out.println("status is :" + status);
		switch (status) {
			case 0:
                saveBindParaAndGotoLogin(arg0);
                break;
            default:
            	System.out.println(" =============  ʧ   ============== ");
                bindAction();
                break;
		}
	}
    

}
